package ace.tellem;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.app.Activity;
import android.util.DisplayMetrics;
import android.util.AttributeSet;
import android.util.Log;
import android.view.Display;
import android.graphics.Point;
import java.lang.System;
import java.util.Properties;
import java.util.Set;
import java.util.Iterator;
import android.view.Menu;
import android.view.MenuItem;
import android.content.Intent;
import android.net.Uri;
import java.net.*;
import java.io.IOException;
import java.util.List;
import java.util.Collections;
import org.apache.http.conn.util.InetAddressUtils;
import android.os.Handler;

public class mainActivity extends Activity
{
	private rtest myrtest;
	private static final String TAG = "MyLog";

	private Handler mHandler;
	private int mInterval = 30000; // every so many milliseconds

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		if(false)
		{
			Properties props = System.getProperties();
			Set set = props.stringPropertyNames();
			Iterator it = set.iterator();
			while(it.hasNext())
			{
				Object v = it.next();
				Log.d(TAG, "something: " + v + "=" + System.getProperty(v.toString()));
			}
		}
//Log.d(TAG, "

//DisplayMetrics metrics = new DisplayMetrics();
//Display d = getWindowManager().getDefaultDisplay();
//d.getMetrics(metrics);
//Log.d(TAG, "density=" + metrics.density);
//Log.d(TAG, "densityDpi=" + metrics.densityDpi);
//Log.d(TAG, "widthPixels=" + metrics.widthPixels);
//Log.d(TAG, "heightPixels=" + metrics.heightPixels);
//Log.d(TAG, "scaledDensity=" + metrics.scaledDensity);
//Log.d(TAG, "xdpi=" + metrics.xdpi);
//Log.d(TAG, "ydpi=" + metrics.ydpi);
//Point p = new Point();
//d.getSize(p);
//Log.d(TAG, "p.x = " + p.x);
//Log.d(TAG, "p.y = " + p.y);
//Log.d(TAG, "refreshrate = " + d.getRefreshRate());

		mHandler = new Handler();
		mStatusChecker.run(); // start sending periodic tellem messages
	}

	@Override
	public void onDestroy()
	{
		super.onDestroy();
		mHandler.removeCallbacks(mStatusChecker);
	}

//http://stackoverflow.com/questions/6242268/repeat-a-task-with-a-time-delay/6242292#6242292
	Runnable mStatusChecker = new Runnable() {
		@Override 
		public void run() {
			sendmsg(); //this function can change value of mInterval.
			mHandler.postDelayed(mStatusChecker, mInterval);
		}
	};
	private void sendmsg() {
		try
		{
			String messageStr= getIPAddress(true) + " android1";
			int server_port = 53831;
			DatagramSocket s = new DatagramSocket();
			s.setBroadcast(true);
			InetAddress local = InetAddress.getByName("255.255.255.255");
			int msg_length=messageStr.length();
			byte[] message = messageStr.getBytes();
			DatagramPacket p = new DatagramPacket(message, msg_length,local,server_port);
			s.send(p);
		}
		catch (SocketException e2) {Log.d(TAG, "fail1");}
		catch (UnknownHostException e2) {Log.d(TAG, "fail2");}
		catch (IOException e2) {Log.d(TAG, "fail3");}
	}

	private String getIPAddress(boolean useIPv4) {
		try {
			List<NetworkInterface> interfaces = Collections.list(NetworkInterface.getNetworkInterfaces());
			for (NetworkInterface intf : interfaces) {
				List<InetAddress> addrs = Collections.list(intf.getInetAddresses());
				for (InetAddress addr : addrs) {
					if (!addr.isLoopbackAddress()) {
						String sAddr = addr.getHostAddress().toUpperCase();
						boolean isIPv4 = InetAddressUtils.isIPv4Address(sAddr); 
						if (useIPv4) {
							if (isIPv4) 
								return sAddr;
						} else {
							if (!isIPv4) {
								int delim = sAddr.indexOf('%'); // drop ip6 port suffix
								return delim<0 ? sAddr : sAddr.substring(0, delim);
							}
						}
					}
				}
			}
		} catch (Exception ex) { } // for now eat exceptions
		return "";
	}


	private static final int ITEM_MENU_0 = 0;
@Override
	 public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(Menu.NONE, ITEM_MENU_0, 0, "About");
//		menu.add(Menu.NONE, ITEM_VISIT_IMDB, 0,
//			getString(R.string.visit_imdb)).setIcon(android.R.drawable.ic_menu_set_as);
//		menu.add(Menu.NONE, ITEM_VIEW_FULL_IMAGE, 0,
//			getString(R.string.view_full_image)).setIcon(android.R.drawable.ic_menu_zoom);
		return super.onCreateOptionsMenu(menu);
	 }

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
			case ITEM_MENU_0:
				Log.d(TAG, "menu 0 pressed");
				String abouturl = "http://www.xdr.com/acedash";
				Intent aboutintent = new Intent(Intent.ACTION_VIEW, Uri.parse(abouturl));
				startActivity(aboutintent);
				return true;
		}
		return false;
	}


}
